
#COMPILE EXE
DEFDBL a - z    'Most calculations in full floating point
GLOBAL pi, dr, re , TropoK, basemast, distmast AS DOUBLE
GLOBAL HDBloc$, LocSites$
'.......................................
FUNCTION ACOS(X) : ACOS = ATN((SQR(1-X*X))/X) + pi/2*(1-SGN(X)) : END FUNCTION
FUNCTION ASIN(X) : ASIN = ATN((X/SQR(1-X*X))) + pi/2*(1-SGN(X)) : END FUNCTION
FUNCTION ATAN2(x,y)
    mag =  SQR(x^2 + y^2)
    IF (mag + x) > 0.00000001 THEN ATAN2 = 2 * ATN(y / (mag + x)) ELSE ATAN2 = -pi
END FUNCTION
'...............................
FUNCTION PBMAIN () AS LONG
    BaseLon = -1  : BaseLat = 51    'Just for a value first time round
    DIM Tiledata(1201, 1201) AS GLOBAL LONG

              ' Main loop used to test functions as they are written
    pi =  3.141592653589793236462643383279
    dr = 180 / pi
    re = 6371.29
    OldTropoK = 1.3
    ty% = 0
    IF DIR$("GeogWin.ini") > "" THEN
        OPEN "GeogWin.INI" FOR INPUT AS #5
        LINE INPUT #5 , HDBloc$
        LINE INPUT #5, LocSites$
        INPUT #5, PlotWindoSize&
    ELSE
        INPUT "Path and Location of Height database files ", HDBloc$
        IF HDBloc$ = "" THEN PRINT "Specify a full path " : END
        INPUT "path and location of SITES.DAT             ", LocSites$
        IF LocSites$ = ""  THEN PRINT "Specify a full path " : END
        INPUT "Plot Window Size     [600]                 ", PlotWindoSize&
        IF PlotWindoSize& = 0 THEN PlotWindoSize& = 600

        IF RIGHT$(HDBloc$ , 1) <>"\" THEN HDBloc$ = HDBloc$ + "\"
        IF RIGHT$(LocSites$ , 1) <>"\" THEN LocSites$ = LocSites$ + "\"

    END IF
    CLS
    COLOR 14
    PRINT "Path Profile from SRTM Data   G4JNT July 2018"
    COLOR 7
    PRINT : PRINT

    IF COMMAND$ = "" THEN LINE INPUT "Base Site Name / Location        "; sn$   ELSE sn$ = COMMAND$
    IF sn$ = "" THEN END

    CALL DecodeSite(sn$ , Lat, Lon, found%)
    IF NOT Found% THEN PRINT "Site not found" : END
    INPUT "Base mast height     [2]         ",basemast
    IF basemast < .01 THEN basemast = 2

    CALL GenFile(Lat, Lon, HtFile$)
    CALL ReadFile(HtFile$)
    OldHtFile$ = HtFile$

    CALL SpotHeight(Lat, Lon, h&)
    CALL LLtoLoc(Lat, Lon , locator$)
    CALL GenNGR(Lat, Lon , NGR$)
    COLOR 6
    PRINT TAB(10); USING$("Base Lat ###.#### Long ###.####  \        \  \         \  ####m AGL",lat ,lon, locator$, NGR$, h&)
    COLOR 7
    PRINT

    PRINT "................................................"
    DO
        PRINT
        PRINT "Site Name / Location [";
        COLOR 5 : PRINT olddn$;
        COLOR 7: PRINT "]"; TAB(34);
        LINE INPUT dn$
        IF dn$ = "" THEN dn$ = Olddn$
        IF INSTR(LCASE$(dn$), "endendend") THEN EXIT LOOP
        Olddn$ = dn$

        INPUT "Distant mast height  [2]         ",distmast
        IF distmast < .01 THEN distmast = 2
        PRINT
        PRINT USING$ ("K value         [#.##]           ",OldTropoK);
        INPUT TropoK
        IF TropoK < .1 THEN TropoK = OldTropoK
        OldTropoK = TropoK

        CALL DecodeSite(dn$ , DistLat, DistLon, found%)
        IF NOT Found% THEN PRINT "Site not found" : ITERATE LOOP
        CALL DistBear(Lat, Lon, DistLat, DistLon, Distance, Bearing, BackBearing)

        COLOR 11 : PRINT TAB(30);USING$("Dist ####.##km  Bearing ###.# [Back ###.#]", Distance,Bearing, BackBearing)
        COLOR 7
        IF maxheight < .1 THEN maxheight = 500
        GRAPHIC DETACH
        nam$ = sn$ + " >> " + dn$ + USING$("####.#km ###.# [Back ###.#]",Distance, Bearing, BackBearing)
        CALL PlotProfile(Lat, Lon, Bearing, Distance, nam$)
     LOOP
     OPEN  "GeogWin.INI" FOR OUTPUT AS #5
     PRINT #5, HDBloc$
     PRINT #5, LocSites$
     PRINT #5, PlotWindoSize&
     CLOSE 5
END FUNCTION

'====================================================================================
SUB LocToLL(locator$, lat, lng)
    locator$ = UCASE$(locator$)
    IF LEN(locator$) < 6 THEN locator$ = locator$ + "LL"
    IF LEN(locator$) < 8  THEN locator$ = locator$ + "44"
    IF LEN(locator$) < 10 THEN locator$ = locator$ + "LL"

    lat = 10 * (ASC(MID$(locator$,2,1))-65) + (ASC(MID$(locator$,4,1))-48) - 90
    lat = lat + (ASC(MID$(locator$,6,1))-65)/24
    lat = lat + (ASC(MID$(locator$,8,1))-48) / 240
    lat = lat + (ASC(MID$(locator$,10,1))-65) / 5760

    lng = 20 * (ASC(MID$(locator$,1,1))-65) + 2 * (ASC(MID$(locator$,3,1))-48) - 180
    lng = lng + (ASC(MID$(locator$,5,1))-65)/12
    lng = lng + (ASC(MID$(locator$,7,1))-48) / 120
    lng = lng + (ASC(MID$(locator$,9,1))-65) / 2880

END SUB

'.............................................................................................
SUB LLtoLoc(lat, lon , locator$)
    x& = (lon + 180) * 2880
    y& = (lat + 90) * 5760

    n1% = (x& \ 57600) MOD 18
    n2% = (y& \ 57600) MOD 18

    n3% = (x& \ 5760) MOD 10
    n4% = (y& \ 5760) MOD 10

    n5% = (x& \ 240) MOD 24
    n6% = (y& \ 240) MOD 24

    n7% = (x& \ 24) MOD 10
    n8% = (y& \ 24) MOD 10

    n9% = x& MOD 24
    n10% = y& MOD 24

    locator$ = CHR$(n1% + 65, n2% + 65, n3% + 48, n4% + 48, n5% + 65, n6% + 65, _
        n7% + 48, n8% + 48, n9% + 65, n10% + 65)
END SUB

'.............................................................................................
SUB DistBear(BaseLat, BaseLon, Lat, Lon, Distance, Bearing, BackBearing)
    BaseLatR = BaseLat / dr :  BaseLonR = BaseLon / dr
    LatR = Lat / dr :  LonR = Lon / dr

    CSarc = SIN(BaseLatR) * SIN(LatR) + COS(BaseLatR) * COS(LatR) * COS(LonR - BaseLonR)
    IF CSarc >1 THEN CSarc = 1
    Angle = ACOS(CSarc)
    Distance = ABS(re * Angle)
    CSbear = (SIN(LatR) - SIN(BaseLatR) * CSarc) / (COS(BaseLatR) * SIN(Angle))
    BackCSbear =  (SIN(BaseLatR) - SIN(LatR) * CSarc) / (COS(LatR) * SIN(Angle))
    IF ABS(CSBear) > 1 THEN CSBear = 1
    IF ABS(BackCsBear) > 1 THEN BackCsBear = 1
    Bearing = dr * ACOS(CSbear)
    BackBearing = dr * ACOS(BackCsBear)

    IF Lon < BaseLon THEN Bearing = 360 - Bearing
    IF BaseLon < Lon THEN BackBearing = 360 - BackBearing
    IF Bearing > 360 THEN Bearing = Bearing - 360
    IF Bearing < 0 THEN Bearing = Bearing + 360
    IF BackBearing > 360 THEN BackBearing = BackBearing - 360
    IF BackBearing < 0 THEN BackBearing = BackBearing + 360
END SUB

'.............................................................................................
SUB DecodeNGR(Ngr$, Lat, Lon)
    Ngr$ = UCASE$(Ngr$)
    DO              'First strip out any spaces
        p& = INSTR(ngr$," ")
        IF p& > 0 THEN ngr$ = LEFT$(ngr$ , p& - 1) + MID$(ngr$ , p& + 1)
    LOOP UNTIL p& = 0

    lett$ = LEFT$(ngr$, 2)
    num$ = MID$(ngr$, 3)

    le% = LEN(num$)
    IF le% >= 8 THEN
        num$ = LEFT$(num$, 3) + MID$(num$, le% / 2 + 1, 3)  'Truncate to 6 digit
    END IF



    num$ = MID$(ngr$, 3)
    le% = LEN(num$)

    PR% = le% / 2
    n = VAL(MID$(num$, PR% + 1, PR%))
    e = VAL(MID$(num$, 1, PR%))
    PR = 10 ^ (5 - PR%)                        'multiplier to get metres
    T1% = ASC(MID$(lett$, 1, 1)) - 65: IF T1% > 8 THEN T1% = T1% - 1
    T2% = ASC(MID$(lett$, 2, 1)) - 65: IF T2% > 8 THEN T2% = T2% - 1
    e = 500000 * (T1% MOD 5) + 100000 * (T2% MOD 5) - 1000000 + e * PR
    n = 1900000 - 500000 * (T1% \ 5) - 100000 * (T2% \ 5) + n * PR
    IF LEN(ngr$) = 8 THEN Resolution# = 0.14 ELSE Resolution# = 0.014

    'Now convert E/N to lat / long

    a1 = 6377563.396 * 0.9996012717      'Use proper OSGB value hereinstead of a simplfied re
    b1 = 6356256.91 * 0.9996012717
    n1 = (a1 - b1) / (a1 + b1)
    e2 = (a1 ^ 2 - b1 ^ 2) / a1 ^ 2
    k = (n + 100000) / a1 + 49 / dr
    DO
        k3 = k - 49 / dr
        k4 = k + 49 / dr
        j3 = (1 + n1 + 5 / 4 * n1 ^ 2 + 5 / 4 * n1 ^ 3) * k3
        j4 = (3 * n1 + 3 * n1 ^ 2 + 21 / 8 * n1 ^ 3) * SIN(k3) * COS(k4)
        j5 = (15 / 8 * n1 ^ 2 + 15 / 8 * n1 ^ 3) * SIN(2 * k3) * COS(2 * k4)
        j6 = 35 / 24 * n1 ^ 3 * SIN(3 * k3) * COS(3 * k4)
        m = b1 * (j3 - j4 + j5 - j6)
        'if abs(n+100000-m)<.001 then exit loop
        k = k + (n + 100000 - m) / a1
    LOOP UNTIL ABS(n + 100000 - m) < 0.001
    v = a1 / SQR(1 - e2 * SIN(k) ^ 2)
    r = v * (1 - e2) / (1 - e2 * SIN(k) ^ 2)
    h2 = v / r - 1
    Y1 = e - 400000
    j3 = TAN(k) / (2 * r * v)
    j4 = TAN(k) / (24 * r * v ^ 3) * (5 + 3 * TAN(k) ^ 2 + h2 - 9 * TAN(k) ^ 2 * h2)
    j5 = TAN(k) / (720 * r * v ^ 5) * (61 + 90 * TAN(k) ^ 2 + 45 * TAN(k) ^ 4)
    k9 = k - Y1 ^ 2 * j3 + Y1 ^ 4 * j4 - Y1 ^ 6 * j5
    j6 = 1 / (COS(k) * v)
    j7 = 1 / (COS(k) * 6 * v ^ 3) * (v / r + 2 * TAN(k) ^ 2)
    j8 = 1 / (COS(k) * 120 * v ^ 5) * (5 + 28 * TAN(k) ^ 2 + 24 * TAN(k) ^ 4)
    j9 = 1 / (COS(k) * 5040 * v ^ 7)
    j9 = j9 * (61 + 662 * TAN(k) ^ 2 + 1320 * TAN(k) ^ 4 + 720 * TAN(k) ^ 6)
    lonA = -2 + dr * (Y1 * j6 - Y1 ^ 3 * j7 + Y1 ^ 5 * j8 - Y1 ^ 7 * j9)
    latA = k9 * dr
   'now convert AIRY to WG84
    CALL AiryToWGS84(LatA, LonA, lat, Lon)
END SUB

'..............................................................................
SUB GenNGR(LatIn, LonIn, ngr$)    'Generate 6 digit (100m) NGR using old OSGB equations
    IF LatIn < 49 OR LatIn > 61 OR LonIn < -8 OR LonIn > 1.8 THEN
        ngr$ = ""
        EXIT SUB
    END IF

    CALL WGS84ToAiry(LatIn, LonIn, k, l)

    a1 = 6377563.396 * 0.9996012717
    b1 = 6356256.91 * 0.9996012717
    n1 = (a1 - b1) / (a1 + b1)
    e2 = (a1 ^ 2 - b1 ^ 2) / a1 ^ 2
    k3 = (k - 49) / dr
    k4 = (k + 49) / dr
    k1 = k / dr
    j3 = (1 + n1 + 5 / 4 * n1 ^ 2 + 5 / 4 * n1 ^ 3) * k3
    j4 = (3 * n1 + 3 * n1 ^ 2 + 21 / 8 * n1 ^ 3) * SIN(k3) * COS(k4)
    j5 = (15 / 8 * n1 ^ 2 + 15 / 8 * n1 ^ 3) * SIN(2 * k3) * COS(2 * k4)
    j6 = 35 / 24 * n1 ^ 3 * SIN(3 * k3) * COS(3 * k4)
    m = b1 * (j3 - j4 + j5 - j6)
    v = a1 / SQR(1 - e2 * SIN(k1) ^ 2)
    r = v * (1 - e2) / (1 - e2 * SIN(k1) ^ 2)
    h2 = v / r - 1

    p = (l + 2) / dr
    j3 = m - 100000
    j4 = v / 2 * SIN(k1) * COS(k1)
    j5 = v / 24 * SIN(k1) * COS(k1) ^ 3 * (5 - TAN(k1) ^ 2 + 9 * h2)
    j6 = v / 720 * SIN(k1) * COS(k1) ^ 5 * (61 - 58 * TAN(k) ^ 2 + TAN(k1) ^ 4)
    n = j3 + p ^ 2 * j4 + p ^ 4 * j5 + p ^ 6 * j6

    j7 = v * COS(k1)
    j8 = v / 6 * COS(k1) ^ 3 * (v / r - TAN(k1) ^ 2)
    j9 = v / 120 * COS(k1) ^ 5
    j9 = j9 * (5 - 18 * TAN(k1) ^ 2 + TAN(k1) ^ 4 + 14 * h2 - 58 * TAN(k1) ^ 2 * h2)
    e = 400000 + p * j7 + p ^ 3 * j8 + p ^ 5 * j9

    'convert EN to NGR

    IF e <= 0 OR e > 700000# OR n <= 0 OR n > 1400000# THEN ngr$ = "Not valid": EXIT SUB

    Ndiv% = 10
    Ndigits% = 4

    easting1% = e \ 100000
    northing1% = n \ 100000
    C1% = 83 - 5 * (northing1% \ 5) + (easting1% \ 5)
    IF C1% = 73 THEN C1% = 72
    eh% = (easting1% MOD 5)
    nh% = (northing1% MOD 5)
    C2% = (4 - nh%) * 5 + eh% + 65
    IF C2% > 72 THEN C2% = C2% + 1
    easting2& = (e - easting1% * 100000) / Ndiv%
    northing2& = (n - northing1% * 100000) / Ndiv%
    CE$ = MID$(STR$(easting2&), 2)
    DO WHILE LEN(CE$) < Ndigits%
        CE$ = "0" + CE$
    LOOP
    CN$ = MID$(STR$(northing2&), 2)
    DO WHILE LEN(CN$) < Ndigits%
        CN$ = "0" + CN$
    LOOP
    ngr$ = CHR$(C1%) + CHR$(C2%) + CE$ + " " + CN$
END SUB

 '.................................................................................
SUB AiryToWGS84(Lat1, Long1, Lat2, Long2)
' Converts Airy Geoid Lat/Long to WGS84 Lat/Long
' Lat and Long are inputs
' From the paper "The Geoid, James Myatt 7 July 2004"
' Lat and Long are inputs

        AiryMajoraxis =         6377563.396            ' Airy Major Axis
        AiryMinoraxis =         6356256.910            ' Airy Minor Axis
        Airyesq =               0.0066705397616        '(AiryMajoraxis * AiryMajoraxis - AiryMinoraxis * AiryMinoraxis) / (AiryMajoraxis * AiryMajoraxis);
        WGS84Majoraxis = 6378137.000  ' WGS84 Major Axis
        WGS84Minoraxis = 6356752.3141 ' WGS84 Minor Axis
        WGS84esq = 0.0066943800355    ' (WGS84Majoraxis * WGS84Majoraxis - WGS84Minoraxis * WGS84Minoraxis) / (WGS84Majoraxis * WGS84Majoraxis);
' 7 parameter Helmert Transform coefficients OSGB - WGS84 values from from James Myatt paper
         tx = 446.448
         ty = -125.157
         tz = 542.060
         s = -20.4894e-6
         rx = 0.1502 / dr / 3600.0
         ry = 0.2470 / dr / 3600.0
         rz = 0.8421 / dr / 3600.0
         h = 0.0

        ' convert to radians
        lat1 = Lat1 / dr
        lon1 = Long1 / dr

        ' convert OSGB lat/lon to X,Y,Z
        v = AiryMajoraxis / SQR(1.0 - Airyesq * SIN(lat1) * SIN(lat1))     ' eqn 2.1
        x1 = (v + h) * COS(lat1) * COS(lon1)                                ' eqn 2.2
        y1 = (v + h) * COS(lat1) * SIN(lon1)                                ' eqn 2.3
        z1 = ((1.0 - Airyesq) * v + h) * SIN(lat1)                          ' eqn 2.4

        ' rotate and translate to new coordinate system
        ' with Helmert Transformation coefficients, eqn 3.1

        x2 = tx + (1.0 + s) * x1 - rz        * y1 + ry       * z1
        y2 = ty + rz        * x1 + (1.0 + s) * y1 - rx       * z1
        z2 = tz - ry        * x1 + rx        * y1 +(1.0 + s) * z1

        ' convert X,Y,Z to WGS84 lat/lon

        lon2 = ATAN2(x2, y2)

        p = SQR(x2 * x2 + y2 * y2)
        lat2 = ATAN2 (p * (1.0 - WGS84esq) , z2)

        DO
                lat = lat2
                v = WGS84Majoraxis / SQR(1.0 - WGS84esq * SIN(lat) * SIN(lat))
                lat2 = ATAN2(p, z2 + WGS84esq * v * SIN(lat))
        LOOP WHILE (ABS(lat - lat2) > 1.0e-8)
              Lat2 = lat2 * dr
              Long2 = lon2 * dr
END SUB
  '.................................................................................
SUB WGS84ToAiry(Lat1,Long1, Lat2, Long2)

' Converts WGS84 Lat/Long to Airy Geoid Lat/Long
' From the paper "The Geoid, James Myatt 7 July 2004"
' Lat and Long are inputs

        AiryMajoraxis =         6377563.396            ' Airy Major Axis
        AiryMinoraxis =         6356256.910            ' Airy Minor Axis
        Airyesq =               0.0066705397616        '(AiryMajoraxis * AiryMajoraxis - AiryMinoraxis * AiryMinoraxis) / (AiryMajoraxis * AiryMajoraxis);
        WGS84Majoraxis = 6378137.000  ' WGS84 Major Axis
        WGS84Minoraxis = 6356752.3141 ' WGS84 Minor Axis
        WGS84esq = 0.0066943800355    ' (WGS84Majoraxis * WGS84Majoraxis - WGS84Minoraxis * WGS84Minoraxis) / (WGS84Majoraxis * WGS84Majoraxis);

        ' 7 parameter Helmert Transform coefficients WGS84 - OSGB
         s = 20.4894e-6 ' scale factor
         tx = -446.448    ' x translation
         ty = 125.157   ' y translation
         tz = -542.060    ' z translation
         rx = -0.1502 / dr / 3600.0  ' x rotation
         ry = -0.2470 / dr / 3600.0  ' y rotation
         rz = -0.8421 / dr / 3600.0  ' z rotation
         h = 0.0 ' Ellipsoidal height (we will set this to zero)

        ' convert to radians
        lat1 = Lat1 / dr
        lon1 = Long1 / dr

        ' convert WGS84 lat/lon to X,Y,Z

        v = WGS84Majoraxis / SQR(1.0 - WGS84esq * SIN(lat1) * SIN(lat1))  ' eqn 2.1

        x1 = (v + h) * COS(lat1) * COS(lon1)                               ' eqn 2.2
        y1 = (v + h) * COS(lat1) * SIN(lon1)                               ' eqn 2.3
        z1 = ((1.0 - WGS84esq) * v + h) * SIN(lat1)                        ' eqn 2.4

        ' rotate and translate to new coordinate system
        ' with Helmert Transformation coefficients, eqn 3.1

        x2 = tx + (1.0 + s) * x1 - rz       * y1 + ry       * z1
        y2 = ty + rz       * x1 + (1.0 + s) * y1 - rx       * z1
        z2 = tz - ry       * x1 + rx        * y1 + (1.0 + s)* z1

        ' convert X,Y,Z back to lat/lon


        lon2 = ATAN2(x2, y2) ' eqn 2.5
        ' Latitude needs iteration

        p = SQR(x2 * x2 + y2 * y2)
        lat2 = ATAN2(p * (1.0 - WGS84esq), z2)


        DO
                lat = lat2
                v = AiryMajoraxis / SQR(1.0 - Airyesq * SIN(lat)* SIN(lat))
                lat2 = ATAN2(p,z2 + Airyesq * v * SIN(lat))

        LOOP WHILE (ABS(lat - lat2) > 1.0e-8)
        Lat2 = lat2 * dr
        Long2 = lon2 * dr
        Lat1 = lat1 * dr
        Long1 = lon1 * dr
 END SUB
  '.................................................................................

'.............................................................................................
SUB DecodeSite(lc$ , Lat, Lon, found%)       'Input is LOC, NGR or a name to search database for
    found% = 0
    c3$ = UCASE$(MID$(lc$, 3 , 1))
    c4$ = UCASE$(MID$(lc$, 4 , 1))

    IF c3$ > "9" OR c4$ > "9" THEN CALL FindSiteInDB(lc$ , Lat, Lon, Found%) : EXIT SUB

    c5$ = UCASE$(MID$(lc$, 5 , 1))
    c6$ = UCASE$(MID$(lc$, 6 , 1))

    IF c5$ >= "0" AND c5$ <= "9" AND c6$ >= "0" AND c6$ <= "9" THEN CALL DecodeNGR(lc$, Lat, Lon) : found% = -1
    IF c5$ >= "A" AND c5$ <= "X" AND c6$ >= "A" AND c6$ <= "X" THEN CALL LocToLL(lc$, Lat, Lon) : found% = -1
    IF found% = 0 THEN CALL FindSiteInDB(lc$ , Lat, Lon, Found%)
END SUB
'.............................................................................................
SUB FindSiteInDB(sn$ , Lat, Lon, Found%)   'Looks for sitename in database, extracts its location and generates its Lat/Long
    found% = 0
    fi$ = LocSites$ + "SITES.DAT"
    IF DIR$(fi$) = "" THEN PRINT fi$ ; " not found" : END
    OPEN fi$ FOR INPUT AS #1
    WHILE NOT EOF(1)
        LINE INPUT #1, s$
        p% = INSTR(s$ , "~")
        ss$ = LEFT$(s$ , p% - 1)
    LOOP UNTIL INSTR(UCASE$(ss$) , UCASE$(sn$)) OR EOF(1)
    IF EOF(1) THEN CLOSE 1 : EXIT SUB
    CLOSE 1
    COLOR 7
    Found% = -1
    p% = INSTR(s$ , "~")
    lc$ = UCASE$(MID$(s$ , p% + 1))

    p% = INSTR(lc$ , "~")
    IF p% THEN lc$ = LEFT$(lc$ , p% - 1)

    c5$ = UCASE$(MID$(lc$, 5 , 1))
    c6$ = UCASE$(MID$(lc$, 6 , 1))

    IF c5$ >= "0" AND c5$ <= "9" AND c6$ >= "0" AND c6$ <= "9" THEN ty% = 1
    IF c5$ >= "A" AND c5$ <= "X" AND c6$ >= "A" AND c6$ <= "X" THEN ty% = 2

    IF ty% = 0  THEN found% = 0 : EXIT SUB      'Invalid location is stored
    IF ty% = 1 THEN CALL DecodeNGR(lc$, Lat, Lon)
    IF ty% = 2 THEN CALL LocToLL(lc$, Lat, Lon)
    sn$ = ss$
END SUB
'.............................................................................................
SUB GenFile(Lat, Lon, Fi$)     'Generates .HGT file name from Lat/Long
    IF Lat < 0 THEN Fi$ = USING$("##",INT(ABS(Lat) + 1)) ELSE Fi$ = USING$("##",INT(ABS(Lat)))
    IF Lat < 0 THEN Fi$ = "S" + Fi$ ELSE Fi$ = "N" + Fi$
    IF Lon < 0 THEN Fi$ = Fi$ + "W" ELSE Fi$ = Fi$ + "E"
    IF Lon < 0 THEN Fi$ = Fi$ + USING$("###",INT(ABS(Lon) + 1)) & ".hgt" ELSE Fi$ = Fi$ + USING$("###",INT(ABS(Lon)), "000") & ".hgt"
    FOR x% = 1 TO LEN(fi$)
        IF MID$(fi$ , x% , 1) = " " THEN   MID$(fi$ , x% , 1) = "0"    'WHY can't USING$ give zero padding !!!!!!!!!!!!!
    NEXT x%
    Fi$ = HDBloc$ + Fi$
    IF DIR$(fi$) = "" THEN PRINT "No HDB"
END SUB
'.............................................................................................
SUB SpotHeight(Lat, Lon, h&)     'Gets single spot height from 1 deg^2 of data stored in TileData array
    FrLat = ABS(Lat) - INT(ABS(Lat))
    FrLon = ABS(Lon) - INT(ABS(Lon))
    Y& = INT(FrLat * 1200)        'Tiles are 1201 each so boundaries are duplicated
    IF Lat < 0 THEN Y& = 1200 - Y&     'Defined from bottom but stored from top
    X& = INT(FrLon * 1200)
    IF Lon < 0 THEN X& = 1200 - X&        'Defined from LH Side
    h& = TileData(x& , y&)
END SUB

'.............................................................................................
SUB ReadFile(Fi$)      'Reads contents of 1 degree .HGT file into TileData(1200, 1200) array
    IF DIR$(fi$) = "" THEN PRINT "No Height file for this location" : EXIT SUB
    OPEN Fi$ FOR BINARY AS #1 BASE = 0
    fulldata$ = STRING$(2884802, 0)  ' = 1201 * 1201 * 2
    GET 1, 0, fulldata$         'Read entire contents into string
    CLOSE 1
    FOR y& = 0 TO 1200          'Then into X,Y array
        fp& = y& * 2402
        FOR x& = 0 TO 1201
            HiByte? = ASC(MID$(fulldata$, X& * 2 + 1 + fp&, 1))
            LoByte? = ASC(MID$(fulldata$, X& * 2 + 2 + fp&, 1))
            h& = LoByte? + 256 * HiByte?
            IF h& > 32768 THEN h& = h& - 65536      'Heights below zero.
            Tiledata(x& , 1200 - y&) = h&      'File is stored downwards
        NEXT x&
    NEXT y&
END SUB
'.............................................................................................
SUB AlongBearing (BaseLat, BaseLon, Bearing, Distance, NewLat, NewLon)   'Gives Lat/Long from a specified point, dkm along a bearing
    GtArc = Distance / re
    lat1 = BaseLat / dr
    lon1 = BaseLon / dr
    theta = Bearing / dr

    Lat2 = ASIN(SIN(Lat1)*COS(GtArc) + COS(Lat1)*SIN(GtArc)*COS(theta))
    Lon2 = Lon1 + ATAN2( COS(GtArc)-SIN(Lat1)*SIN(Lat2),SIN(theta)*SIN(GtArc)*COS(Lat1))
    NewLat = Lat2 * dr
    NewLon = Lon2 * dr
END SUB
'.............................................................................................

SUB Cols(k&, co&)         ' Enter with K scaled 0 to 255, exit with waterfall RBG colour

    th1 = 256
    th2 = 511
    th3 = 767
    th4 = 1023
    th5 = 1279
    IF k& > 256 THEN k = 255
    IF k& < 0 THEN k = 0

    q = k& * 6
    s? = q MOD 256


       SELECT CASE q

        CASE IS <= th1       'black to blue
            r? = 0
            g? = 0
            b? = s?
        CASE IS <= th2       'blue to cyan
            r? = 0
            g? = s?
            b? = 255
        CASE IS <= th3       'cyan to green
            r? = 0
            g? = 255
            b? = 255 - s?
        CASE IS <= th4      'green to yellow
            r? = s?
            g? = 255
            b? = 0
        CASE IS <= th5      'yellow to red
            r? = 255
            g? = 255 - s?
            b? = 0
        CASE ELSE           'red to white
            r? = 255
            g? = s?
            b? = s?
        END SELECT

    co& = RGB(r?, g?, b?)

END SUB

SUB PlotTile          'Plots waterfall  of a single tile   (test prog only)
    GRAPHIC WINDOW NEW "Tile Height Plot"   , 800 , 60  , 600 * COS(51) , 600 TO HW&
    GRAPHIC SCALE (0,0) - (1201 , 1201)
    GRAPHIC ATTACH HW&, 0
    GRAPHIC WINDOW STABILIZE

       FOR y% = 1201 TO 0 STEP -1   'Plot downwards to make it look better
        FOR x% = 0 TO 1201
            c& = TileData(x% , y%)
            CALL cols(c& , col&)
            GRAPHIC SET PIXEL (x% , 1201 - y%) , col&
        NEXT x%
    NEXT y%
END SUB
  '...........................................................
SUB NearestSite (BaseLat, BaseLon, sn$, MissDist)   'Searches database for site nearest to base, retunrs with name and distance from
 OPEN LocSites$ + "sites.dat" FOR INPUT AS #2
 MissDist = 9999999
 WHILE NOT EOF(2)
    LINE INPUT #2, s$
    p% = INSTR(s$ , "~")
    ss$ = LEFT$(s$ , p% - 1)
    lc$ = UCASE$(MID$(s$ , p% + 1))
    p% = INSTR(lc$ , "~")
    IF p% THEN lc$ = LEFT$(lc$ , p% - 1)

    c5$ = UCASE$(MID$(lc$, 5 , 1))
    c6$ = UCASE$(MID$(lc$, 6 , 1))

    IF c5$ >= "0" AND c5$ <= "9" AND c6$ >= "0" AND c6$ <= "9" THEN ty% = 1
    IF c5$ >= "A" AND c5$ <= "X" AND c6$ >= "A" AND c6$ <= "X" THEN ty% = 2

    IF ty% = 0  THEN ITERATE LOOP      'Invalid location is stored
    IF ty% = 1 THEN CALL DecodeNGR(lc$, Lat, Lon)
    IF ty% = 2 THEN CALL LocToLL(lc$, Lat, Lon)

    CALL DistBear(BaseLat, BaseLon, Lat, Lon, Dist, Bearing, BackBearing)
    IF Dist < MissDist THEN sn$ = ss$ : MissDist = Dist
 LOOP UNTIL EOF(2)
 CLOSE 2
END SUB
'...............................................

SUB PlotProfile(BaseLat, BaseLon, Bearing, dist, nam$)    'Test prog, plots profile between two sites
    DIM PlotPoints(100000)
    PRINT
    OldTropoK = 1.3
    effre = re * TropoK
    y0 =  1000 * SQR(effre ^2 - dist^2 / 4)     'Effective height of midpoint of earth's curvature

    StepInt = MIN(.03, dist / 1000)
    StepInt = .02       'Less than one pixel
    first% = -1
    x& =0
    FOR along = 0 TO Dist STEP StepInt
        groundheight = 1000 * SQR(effre ^2 - (along - dist / 2) ^ 2) - y0
        CALL AlongBearing (BaseLat, BaseLon, Bearing, along, Lat2, Lon2)
        CALL GenFile(Lat2, Lon2, HtFile$)
        IF HtFile$ <> OldHtFile$ THEN
            CALL ReadFile(HtFile$)
            OldHtFile$ = HtFile$
        END IF
        CALL SpotHeight(Lat2, Lon2, h&)
        PlotPoints(x&) = h& + groundheight
        maxheight = MAX(maxheight , PlotPoints(x&))
        INCR x&
    NEXT along
    Xcount& = x& - 1

   'Set up the plot
    maxheight = maxheight * 1.2
    GRAPHIC WINDOW NEW nam$   , 100 , 60  , 800  , 400 TO HW&
    GRAPHIC SCALE (-dist * .05 , maxheight) - (dist*1.1 , -maxheight / 20)
    GRAPHIC ATTACH HW&, 0
    GRAPHIC WINDOW STABILIZE

    GRAPHIC BOX (dist * 1.05, maxheight * .4) - (dist* 1.08 , maxheight * .5),, RGB(255, 0 , 0) , -1
    GRAPHIC LINE (dist * 1.051, maxheight * .41) - (dist* 1.079 , maxheight * .49), RGB(0,0,0)
    GRAPHIC LINE (dist * 1.051, maxheight * .49) - (dist* 1.079 , maxheight * .41), RGB(0,0,0)
    GRAPHIC SET POS (dist * 1.05, maxheight * .39)
    GRAPHIC PRINT "Exit";

   'Draw the axes
    GRAPHIC STYLE 2

    IF maxheight < 500 THEN Hin& = 20 ELSE Hin& = 50
    IF maxheight < 200 THEN Hin& = 10
    FOR hscale& = 0 TO maxheight STEP Hin&
        GRAPHIC LINE (0 , hscale&) - (dist, hscale&) , RGB(200,200,200)
        GRAPHIC SET POS (dist * 1.005, hscale&+2 )
        GRAPHIC PRINT hscale&
    NEXT hscale&

    IF Dist < 100 THEN Dint& = 5 ELSE Dint& = 10
    IF Dist < 20 THEN Dint& = 1
    FOR dscale& = 0 TO Dist STEP Dint&
        GRAPHIC LINE (dscale& , 0) - (dscale& , maxheight), RGB(200,200,200)
        GRAPHIC SET POS (dscale& , -1)
        GRAPHIC PRINT dscale&;
    NEXT dscale&
    GRAPHIC STYLE 0

   'Do the plot
    along = 0
    col& = RGB(200,100,20)
    FOR x& = 0 TO Xcount&
        groundheight = 1000 * SQR(effre ^2 - (along - dist / 2) ^ 2) - y0
        GRAPHIC LINE(along, 0) - (along , groundheight), RGB(0,200,0)

        h& = PlotPoints(x&)
        GRAPHIC LINE - (along,h&) , col&
'        IF first% THEN GRAPHIC SET PIXEL (0, h&), col& ELSE GRAPHIC LINE (along - StepInt, oldh&) - (along, h&), col&
        along = along + StepInt
        oldh& = h&
        first% = 0
    NEXT counter

   'show masts
    GRAPHIC WIDTH 4
    GRAPHIC LINE (0, PlotPoints(0)) - (0, PlotPoints(0) + basemast), RGB (255,0,0)
    GRAPHIC LINE (dist, PlotPoints(Xcount&)) - (dist, PlotPoints(Xcount&) + distmast), RGB (255,0,0)
    GRAPHIC WIDTH 1
    GRAPHIC STYLE 2
    GRAPHIC LINE (0, PlotPoints(0) + basemast) - (dist, PlotPoints(Xcount&) + distmast) , RGB(50,80,0)

  'Mouse click to show intermediate locations, double click to show LOS paths to cursor
    GRAPHIC STYLE 3
    GRAPHIC WIDTH 1
    DO
        GRAPHIC WINDOW CLICK TO dummy& , mx, my
        IF dummy& THEN
            IF (mx > dist * 1.05) AND (my > maxheight * .4) AND (my < maxheight * .5)  THEN
                CON.FOCUS
                GRAPHIC WINDOW END
                EXIT LOOP
            END IF
            CALL AlongBearing (BaseLat, BaseLon, Bearing, mx, Lat2, Lon2)
            CALL LLtoLoc(Lat2, Lon2 , locator$)
            CALL GenNGR(Lat2, Lon2 , NGR$)
            groundheight = 1000 * SQR(effre ^2 - (mx - dist / 2) ^ 2) - y0

            IF dummy& = 2 THEN   'Double click
                GRAPHIC LINE (0, PlotPoints(0) + basemast) - (mx,my) , RGB(200,0,200)
                GRAPHIC LINE (mx,my) - (dist, PlotPoints(Xcount&) + distmast) , RGB(200,0,200)
            END IF

            GRAPHIC SET POS (dist * .2, 10)
            GRAPHIC PRINT " " + locator$ + " = " + ngr$ + USING$("  ####.#m AGL  "; my - groundheight);
            CALL NearestSite (Lat2, Lon2, NearSite$, MissDist)
            GRAPHIC PRINT USING$( "Nearest site \                         \  ###.#km   ",NearSite$,MissDist)

            GRAPHIC INSTAT TO gr&
            IF gr& THEN EXIT LOOP
        END IF
    LOOP
 END SUB
