#COMPILE EXE
DEFDBL a - z    'Most calculations in full floating point
GLOBAL pi, dr, re , TropoK, basemast, distmast AS DOUBLE
GLOBAL HDBloc$, LocSites$
'.......................................
FUNCTION ACOS(X) : ACOS = ATN((SQR(1-X*X))/X) + pi/2*(1-SGN(X)) : END FUNCTION
FUNCTION ASIN(X) : ASIN = ATN((X/SQR(1-X*X))) + pi/2*(1-SGN(X)) : END FUNCTION
FUNCTION ATAN2(x,y)
    mag =  SQR(x^2 + y^2)
    IF (mag + x) > 0.00000001 THEN ATAN2 = 2 * ATN(y / (mag + x)) ELSE ATAN2 = -pi
END FUNCTION
'...............................
FUNCTION PBMAIN () AS LONG
    DIM Tiledata(1201, 1201) AS GLOBAL LONG
    DIM HgtData(10000, 6000) AS GLOBAL LONG     'Allows for about 600km square at 3" pixel resolution
              ' Main loop used to test functions as they are written
    pi =  3.141592653589793236462643383279
    dr = 180 / pi
    re = 6371.29
    TropoK = 1.3
    ty% = 0
    IF DIR$("GeogWin.ini") > "" THEN
        OPEN "GeogWin.INI" FOR INPUT AS #5
        LINE INPUT #5 , HDBloc$
        LINE INPUT #5, LocSites$
        INPUT #5, PlotWindoSize&
    ELSE
        INPUT "Path and Location of Height database files ", HDBloc$
        IF HDBloc$ = "" THEN PRINT "Specify a full path " : END
        INPUT "path and location of SITES.DAT             ", LocSites$
        IF LocSites$ = ""  THEN PRINT "Specify a full path " : END
        INPUT "Plot Window Size     [600]                 ", PlotWindoSize&
        IF PlotWindoSize& = 0 THEN PlotWindoSize& = 600

        IF RIGHT$(HDBloc$ , 1) <>"\" THEN HDBloc$ = HDBloc$ + "\"
        IF RIGHT$(LocSites$ , 1) <>"\" THEN LocSites$ = LocSites$ + "\"

    END IF
    CLOSE 5
    CLS
    COLOR 14
    PRINT "Visible Terrain Plot   G4JNT July 2018"
    COLOR 7
    PRINT : PRINT

    IF COMMAND$ > "" THEN sn$ = COMMAND$ ELSE _
    LINE INPUT "Centre of plot, Site Name / Location     "; sn$
    IF sn$ = "" THEN END

    CALL DecodeSite(sn$ , Lat, Lon, found%)
    IF NOT Found% THEN PRINT "Site not found" : END
    INPUT "Base mast height          [2]            ",basemast
    IF basemast < .01 THEN basemast = 2
    PRINT
    INPUT "Tropo  K  value          [1.3]           ";TropoK
    IF TropoK < .01 THEN TropoK = 1.3
    PRINT
    CALL GenFile(Lat, Lon, HtFile$)
    CALL ReadFile(HtFile$)
 '   CALL SpotHeight(Lat, Lon, baseHeight&)
    CALL SpotHgtFile(Lat, Lon, baseHeight&)
    CALL LLtoLoc(Lat, Lon , locator$)
    CALL GenNGR(Lat, Lon , NGR$)
    PRINT
    DefaultPlot = 10 * INT(.14 * SQR(2 * re * TropoK * (baseHeight& + basemast)/1000))
    PRINT USING$( "Radial Distance Out km    [###]          ";DefaultPlot);
    INPUT PlotSize
    IF PlotSize < .001 THEN PlotSize = DefaultPlot


    COLOR 6
    PRINT TAB(10); USING$("Base Lat ###.#### Long ###.####  \        \  \         \  ####m AGL",lat ,lon, locator$, NGR$, BaseHeight&)
    COLOR 7

    PixelSize = 111.2/1200          'Gt circle Size in km of each 3" squareoid in height database
    PixelsVert& =  MIN(PlotSize * 2 / PixelSize, 6000)
    PixelsHor& = MIN(PixelsVert& / COS(Lat / dr), 10000)

      ''''''''''''''''''''''''''''''''''''
'  COLOR 14 :PRINT "Pixels ";PixelsHor&; " x " ; PixelsVert& : PRINT : COLOR 7

    LonStart =  (Lon - PlotSize / 111.2 /COS(Lat / dr) )    'Exact stop and start values
    LonStop  =  (Lon + PlotSize / 111.2 /COS(Lat / dr) )      '
    LatStart =  (Lat - PlotSize / 111.2 )
    LatStop  =  (Lat + PlotSize / 111.2 )

    ArrayLeft& = INT(LonStart)       'Actual start points of the stored data.
    ArrayBottom& = INT(LatStart)     'Integral degrees. INT function of -ve fractions goes DOWN
    XpixelStart& = FRAC(LonStart) * 1200 : IF  XpixelStart& < 0 THEN XpixelStart& = 1200 + XpixelStart&
    YpixelStart& = FRAC(LatStart) * 1200 : IF  YpixelStart& < 0 THEN YpixelStart& = 1200 + YpixelStart&
'''
 'color 14 : PRINT "Start into array at X,Y ";XpixelStart&;",";YpixelStart&;" counting for  ";",";PixelsHor&;PixelsVert&
 'PRINT USING$("From Lat/Long  ###.### , ###.###    to  ###.###, ###.###",LatStart, LonStart, LatStop, LonStop) : color 7

  'Fill the HgtData Array with complete tile contents from each one needed
    oldfi$ = ""

    maxh = -9999999
    minh = 9999999
    COLOR 13 : PRINT "Loading Height data from SRTM files" : COLOR 7
    FOR x&  = INT (LonStart)TO INT(LonStop) STEP 1
        Xcorner& = (x& - INT(LonStart)) * 1200
        FOR y& = INT(LatStart) TO INT(LatStop) STEP 1       'INT supplies the left / bottommost value
            Ycorner& = (y& - INT(LatStart)) * 1200
             CALL GenFile(y&+.00001, x&+.00001, fi$)   'Small delta needed coz rounding of the INT above takes it downwards.  Also forces a double float to be passe
             IF fi$ = "" THEN PRINT "Skipped"
                IF fi$ <> oldfi$ AND fi$ > "" THEN                 'Copy into HgtData, ignoring those outside boudary
                oldfi$ =  fi$
                PRINT fi$
                CALL ReadFile(fi$)
                FOR Xcopy& = 0 TO 1200
                    Xpointer& = Xcorner& + Xcopy&
                    FOR Ycopy& = 0 TO 1200
                        Ypointer& = Ycorner& + Ycopy&
                        h = TileData(Xcopy& , Ycopy&)
                        HgtData(Xpointer& , Ypointer&) = h
                        maxh = MAX(h , maxh)
                        minh = MIN(h , minh)
                    NEXT Ycopy&
                NEXT Xcopy&

               END IF
        NEXT y&
    NEXT x&

' Plot pixels in x and y are in units of deg / 1200 from LonStart, LatStart at BLHS
'  Plot scale is adjusted for a square of plotsize
    PRINT "Min Max heights ";minh;maxh
    GRAPHIC WINDOW NEW "Viewable spots, centred on " + sn$ + USING$("   Mast height ###m",basemast)   , 400 , 0  , PlotWindoSize& , PlotWindoSize& TO HW&, HIDE
    GRAPHIC SCALE (0,PixelsVert& * 1.1) - (PixelsHor& * 1.07 , -PixelsVert& * .03)
    GRAPHIC LINE(PixelsHor& * 1.05 , PixelsVert&) - (0, 0), %WHITE
    GRAPHIC ATTACH HW&, 0 , REDRAW
    GRAPHIC WINDOW STABILIZE
    GRAPHIC BOX (PixelsHor& * 1.03, PixelsVert&) - (PixelsHor& * 1.05, PixelsVert&* 0.97),,%RED, %RED

    GRAPHIC LINE (PixelsHor& *1.05, PixelsVert&) - (PixelsHor& * 1.03, PixelsVert&* 0.97),0
    GRAPHIC LINE (PixelsHor& *1.03, PixelsVert&) - (PixelsHor& * 1.05, PixelsVert&* 0.97),0
    GRAPHIC SET POS (PixelsHor& * 1.02 , PixelsVert&* 0.96)
    GRAPHIC COLOR %BLACK
    GRAPHIC PRINT "Exit"

    GRAPHIC BOX (0 , 0) - (PixelsHor&, PixelsVert&) ,, 0 , 0    'Dark background
    bearingincr = dr * 0.08 /PlotSize   'Bit less than one pixel at max radius
    increment = .08/PlotSize            'Ditto

    GRAPHIC WINDOW NORMALIZE
    GRAPHIC REDRAW
    FOR Bearing = 0 TO 360 STEP bearingincr   'Degrees
        maxheight = 0
        maxtheta1 = -99
        angle = (90 - bearing) /dr
        xmult = COS(angle)
        ymult = SIN(angle)
        HorizonDist = 0
        FOR Along = increment TO 1 STEP increment
            DistAlong = PlotSize * Along
            x& = (along * xmult + 1) /2 * PixelsHor&
            y& = (along * ymult + 1) /2 * PixelsVert&
            h& = HgtData(XpixelStart& + x&, YpixelStart& + y&)
            theta1 = ((h& - BaseHeight& - basemast) / 1000 / DistAlong - DistAlong/ 2 / re / TropoK )    'Typical values -0.02 rad to +0.05 ra

             'An attempt to use the exact trig equations based on cosine and sine rules
     '       Bq = re * TropoK + (BaseHeight& + basemast) / 1000        'A
     '       Cq = re * TropoK + h& / 1000
     '       aarc = DistAlong / re / TropoK
     '       Aq= SQR(Bq^2 + Cq^2 - 2* Bq * Cq * COS(aarc))    'COS rule
     '       theta1 =  ASIN(Cq / Aq * SIN(aarc)) - pi/2     'Sine rule. Then angle measured wrt. local ground, so 90 deg from calculated A
     '       IF (BaseHeight& + basemast) < h& THEN theta1 = -theta1

            IF theta1 > maxtheta1 THEN
                maxtheta1 = theta1        'Typical values  -.02 to +0.05
                horizondist = DistAlong
                k& = MIN(255, MAX(0 , (0.05 - theta1)* 2000))
                CALL Cols(k&, col&)
                GRAPHIC SET PIXEL (x&, y&) ,col&
            ELSE
                col& = RGB(0,60,60)
            END IF
        NEXT Along
        progress% = (bearing / 360) * 40
        IF progress% > LastProg% THEN GRAPHIC REDRAW : LastProg% = progress%
    NEXT Bearing
    GRAPHIC REDRAW
    DO
        GRAPHIC WINDOW CLICK TO dummy& , mx, my
        IF dummy& THEN
            IF mx > PixelsHor& *1.03 AND my > PixelsVert&* 0.97 THEN
                CON.FOCUS
                GRAPHIC WINDOW END
                EXIT LOOP
            END IF

            mLon = LonStart  + mx / 1200
            mLat = LatStart  + my /1200
            CALL LLtoLoc(mLat, mLon , locator$)
            CALL GenNGR(mLat, mLon , NGR$)
            DistBear(Lat, Lon, mLat, mLon, Distance, Bearing, BackBearing)
            CALL SpotHgtFile(mLat, mLon, mH&)      'Change XXX once proven

            IF dummy& = 1 THEN
                GRAPHIC SET POS (PixelsHor& * .01, -PixelsVert& * .005)
                GRAPHIC PRINT SPACE$(80)
                GRAPHIC SET POS (PixelsHor& * .6, -PixelsVert& * .005)
                GRAPHIC COLOR %BLUE,%WHITE
                GRAPHIC PRINT locator$; " = "  ;ngr$ ;
                GRAPHIC PRINT USING$("   ####km  ### (###)  ",  Distance, Bearing, BackBearing);
                GRAPHIC COLOR   RGB(200,0,160)
                GRAPHIC PRINT USING$("#### m           ",mH&)
             END IF

            IF dummy& = 2 THEN   'Double click
                CALL NearestSite (mLat, mLon, sn$, MissDist)
                CALL FindSiteInDB(sn$ , sLat, sLon, Found%)
                sx = (slon - LonStart) * 1200
                sy = (sLat - LatStart) * 1200
                sz = PixelsHor& / 200
                GRAPHIC BOX (sx,sy) - (sx+ (sz)/ COS(Lat / dr), sy+sz),,%BLACK,%WHITE
                GRAPHIC SET POS (sx, sy)
                GRAPHIC COLOR %WHITE, -2
                GRAPHIC PRINT sn$

                GRAPHIC SET POS (PixelsHor& * .01, -PixelsVert& * .005)
                GRAPHIC COLOR %RED,%WHITE
                GRAPHIC PRINT sn$ + SPACE$(75)
             END IF
            GRAPHIC REDRAW
        END IF
        GRAPHIC INKEY$ TO gr$
        IF gr$ = CHR$(27) THEN EXIT LOOP
        SLEEP 100
    LOOP
    OPEN  "GeogWin.INI" FOR OUTPUT AS #5
    PRINT #5, HDBloc$
    PRINT #5, LocSites$
    PRINT #5, PlotWindoSize&
    CLOSE 5
      '................................................"

END FUNCTION

'====================================================================================
SUB LocToLL(locator$, lat, lng)
    locator$ = UCASE$(locator$)
    IF LEN(locator$) < 6 THEN locator$ = locator$ + "LL"
    IF LEN(locator$) < 8  THEN locator$ = locator$ + "44"
    IF LEN(locator$) < 10 THEN locator$ = locator$ + "LL"

    lat = 10 * (ASC(MID$(locator$,2,1))-65) + (ASC(MID$(locator$,4,1))-48) - 90
    lat = lat + (ASC(MID$(locator$,6,1))-65)/24
    lat = lat + (ASC(MID$(locator$,8,1))-48) / 240
    lat = lat + (ASC(MID$(locator$,10,1))-65) / 5760

    lng = 20 * (ASC(MID$(locator$,1,1))-65) + 2 * (ASC(MID$(locator$,3,1))-48) - 180
    lng = lng + (ASC(MID$(locator$,5,1))-65)/12
    lng = lng + (ASC(MID$(locator$,7,1))-48) / 120
    lng = lng + (ASC(MID$(locator$,9,1))-65) / 2880

END SUB

'.............................................................................................
SUB LLtoLoc(lat, lon , locator$)
    x& = (lon + 180) * 2880
    y& = (lat + 90) * 5760

    n1% = (x& \ 57600) MOD 18
    n2% = (y& \ 57600) MOD 18

    n3% = (x& \ 5760) MOD 10
    n4% = (y& \ 5760) MOD 10

    n5% = (x& \ 240) MOD 24
    n6% = (y& \ 240) MOD 24

    n7% = (x& \ 24) MOD 10
    n8% = (y& \ 24) MOD 10

    n9% = x& MOD 24
    n10% = y& MOD 24

    locator$ = CHR$(n1% + 65, n2% + 65, n3% + 48, n4% + 48, n5% + 65, n6% + 65, _
        n7% + 48, n8% + 48, n9% + 65, n10% + 65)
END SUB

'.............................................................................................
SUB DistBear(BaseLat, BaseLon, Lat, Lon, Distance, Bearing, BackBearing)
    BaseLatR = BaseLat / dr :  BaseLonR = BaseLon / dr
    LatR = Lat / dr :  LonR = Lon / dr

    CSarc = SIN(BaseLatR) * SIN(LatR) + COS(BaseLatR) * COS(LatR) * COS(LonR - BaseLonR)
    IF CSarc >1 THEN CSarc = 1
    Angle = ACOS(CSarc)
    Distance = ABS(re * Angle)
    CSbear = (SIN(LatR) - SIN(BaseLatR) * CSarc) / (COS(BaseLatR) * SIN(Angle))
    BackCSbear =  (SIN(BaseLatR) - SIN(LatR) * CSarc) / (COS(LatR) * SIN(Angle))
    IF ABS(CSBear) > 1 THEN CSBear = 1
    IF ABS(BackCsBear) > 1 THEN BackCsBear = 1
    Bearing = dr * ACOS(CSbear)
    BackBearing = dr * ACOS(BackCsBear)

    IF Lon < BaseLon THEN Bearing = 360 - Bearing
    IF BaseLon < Lon THEN BackBearing = 360 - BackBearing
    IF Bearing > 360 THEN Bearing = Bearing - 360
    IF Bearing < 0 THEN Bearing = Bearing + 360
    IF BackBearing > 360 THEN BackBearing = BackBearing - 360
    IF BackBearing < 0 THEN BackBearing = BackBearing + 360
END SUB

'.............................................................................................
SUB DecodeNGR(Ngr$, Lat, Lon)
    Ngr$ = UCASE$(Ngr$)
    DO              'First strip out any spaces
        p& = INSTR(ngr$," ")
        IF p& > 0 THEN ngr$ = LEFT$(ngr$ , p& - 1) + MID$(ngr$ , p& + 1)
    LOOP UNTIL p& = 0
    lett$ = LEFT$(ngr$, 2)
    num$ = MID$(ngr$, 3)

    le% = LEN(num$)
    IF le% >= 8 THEN
        num$ = LEFT$(num$, 3) + MID$(num$, le% / 2 + 1, 3)  'Truncate to 6 digit
    END IF


    num$ = MID$(ngr$, 3)
    le% = LEN(num$)

    PR% = le% / 2
    n = VAL(MID$(num$, PR% + 1, PR%))
    e = VAL(MID$(num$, 1, PR%))
    PR = 10 ^ (5 - PR%)                        'multiplier to get metres
    T1% = ASC(MID$(lett$, 1, 1)) - 65: IF T1% > 8 THEN T1% = T1% - 1
    T2% = ASC(MID$(lett$, 2, 1)) - 65: IF T2% > 8 THEN T2% = T2% - 1
    e = 500000 * (T1% MOD 5) + 100000 * (T2% MOD 5) - 1000000 + e * PR
    n = 1900000 - 500000 * (T1% \ 5) - 100000 * (T2% \ 5) + n * PR
    IF LEN(ngr$) = 8 THEN Resolution# = 0.14 ELSE Resolution# = 0.014

    'Now convert E/N to lat / long

    a1 = 6377563.396 * 0.9996012717      'Use proper OSGB value hereinstead of a simplfied re
    b1 = 6356256.91 * 0.9996012717
    n1 = (a1 - b1) / (a1 + b1)
    e2 = (a1 ^ 2 - b1 ^ 2) / a1 ^ 2
    k = (n + 100000) / a1 + 49 / dr
    DO
        k3 = k - 49 / dr
        k4 = k + 49 / dr
        j3 = (1 + n1 + 5 / 4 * n1 ^ 2 + 5 / 4 * n1 ^ 3) * k3
        j4 = (3 * n1 + 3 * n1 ^ 2 + 21 / 8 * n1 ^ 3) * SIN(k3) * COS(k4)
        j5 = (15 / 8 * n1 ^ 2 + 15 / 8 * n1 ^ 3) * SIN(2 * k3) * COS(2 * k4)
        j6 = 35 / 24 * n1 ^ 3 * SIN(3 * k3) * COS(3 * k4)
        m = b1 * (j3 - j4 + j5 - j6)
        'if abs(n+100000-m)<.001 then exit loop
        k = k + (n + 100000 - m) / a1
    LOOP UNTIL ABS(n + 100000 - m) < 0.001
    v = a1 / SQR(1 - e2 * SIN(k) ^ 2)
    r = v * (1 - e2) / (1 - e2 * SIN(k) ^ 2)
    h2 = v / r - 1
    Y1 = e - 400000
    j3 = TAN(k) / (2 * r * v)
    j4 = TAN(k) / (24 * r * v ^ 3) * (5 + 3 * TAN(k) ^ 2 + h2 - 9 * TAN(k) ^ 2 * h2)
    j5 = TAN(k) / (720 * r * v ^ 5) * (61 + 90 * TAN(k) ^ 2 + 45 * TAN(k) ^ 4)
    k9 = k - Y1 ^ 2 * j3 + Y1 ^ 4 * j4 - Y1 ^ 6 * j5
    j6 = 1 / (COS(k) * v)
    j7 = 1 / (COS(k) * 6 * v ^ 3) * (v / r + 2 * TAN(k) ^ 2)
    j8 = 1 / (COS(k) * 120 * v ^ 5) * (5 + 28 * TAN(k) ^ 2 + 24 * TAN(k) ^ 4)
    j9 = 1 / (COS(k) * 5040 * v ^ 7)
    j9 = j9 * (61 + 662 * TAN(k) ^ 2 + 1320 * TAN(k) ^ 4 + 720 * TAN(k) ^ 6)
    lonA = -2 + dr * (Y1 * j6 - Y1 ^ 3 * j7 + Y1 ^ 5 * j8 - Y1 ^ 7 * j9)
    latA = k9 * dr
   'now convert AIRY to WG84
    CALL AiryToWGS84(LatA, LonA, lat, Lon)
END SUB

'..............................................................................
SUB GenNGR(LatIn, LonIn, ngr$)    'Generate 6 digit (100m) NGR using old OSGB equations
    IF LatIn < 49 OR LatIn > 61 OR LonIn < -8 OR LonIn > 1.8 THEN
        ngr$ = ""
        EXIT SUB
    END IF

    CALL WGS84ToAiry(LatIn, LonIn, k, l)

    a1 = 6377563.396 * 0.9996012717
    b1 = 6356256.91 * 0.9996012717
    n1 = (a1 - b1) / (a1 + b1)
    e2 = (a1 ^ 2 - b1 ^ 2) / a1 ^ 2
    k3 = (k - 49) / dr
    k4 = (k + 49) / dr
    k1 = k / dr
    j3 = (1 + n1 + 5 / 4 * n1 ^ 2 + 5 / 4 * n1 ^ 3) * k3
    j4 = (3 * n1 + 3 * n1 ^ 2 + 21 / 8 * n1 ^ 3) * SIN(k3) * COS(k4)
    j5 = (15 / 8 * n1 ^ 2 + 15 / 8 * n1 ^ 3) * SIN(2 * k3) * COS(2 * k4)
    j6 = 35 / 24 * n1 ^ 3 * SIN(3 * k3) * COS(3 * k4)
    m = b1 * (j3 - j4 + j5 - j6)
    v = a1 / SQR(1 - e2 * SIN(k1) ^ 2)
    r = v * (1 - e2) / (1 - e2 * SIN(k1) ^ 2)
    h2 = v / r - 1

    p = (l + 2) / dr
    j3 = m - 100000
    j4 = v / 2 * SIN(k1) * COS(k1)
    j5 = v / 24 * SIN(k1) * COS(k1) ^ 3 * (5 - TAN(k1) ^ 2 + 9 * h2)
    j6 = v / 720 * SIN(k1) * COS(k1) ^ 5 * (61 - 58 * TAN(k) ^ 2 + TAN(k1) ^ 4)
    n = j3 + p ^ 2 * j4 + p ^ 4 * j5 + p ^ 6 * j6

    j7 = v * COS(k1)
    j8 = v / 6 * COS(k1) ^ 3 * (v / r - TAN(k1) ^ 2)
    j9 = v / 120 * COS(k1) ^ 5
    j9 = j9 * (5 - 18 * TAN(k1) ^ 2 + TAN(k1) ^ 4 + 14 * h2 - 58 * TAN(k1) ^ 2 * h2)
    e = 400000 + p * j7 + p ^ 3 * j8 + p ^ 5 * j9

    'convert EN to NGR

    IF e <= 0 OR e > 700000# OR n <= 0 OR n > 1400000# THEN ngr$ = "Not valid": EXIT SUB

    Ndiv% = 10
    Ndigits% = 4

    easting1% = e \ 100000
    northing1% = n \ 100000
    C1% = 83 - 5 * (northing1% \ 5) + (easting1% \ 5)
    IF C1% = 73 THEN C1% = 72
    eh% = (easting1% MOD 5)
    nh% = (northing1% MOD 5)
    C2% = (4 - nh%) * 5 + eh% + 65
    IF C2% > 72 THEN C2% = C2% + 1
    easting2& = (e - easting1% * 100000) / Ndiv%
    northing2& = (n - northing1% * 100000) / Ndiv%
    CE$ = MID$(STR$(easting2&), 2)
    DO WHILE LEN(CE$) < Ndigits%
        CE$ = "0" + CE$
    LOOP
    CN$ = MID$(STR$(northing2&), 2)
    DO WHILE LEN(CN$) < Ndigits%
        CN$ = "0" + CN$
    LOOP
    ngr$ = CHR$(C1%) + CHR$(C2%) + CE$ + " " + CN$
END SUB

 '.................................................................................
SUB AiryToWGS84(Lat1, Long1, Lat2, Long2)
' Converts Airy Geoid Lat/Long to WGS84 Lat/Long
' Lat and Long are inputs
' From the paper "The Geoid, James Myatt 7 July 2004"
' Lat and Long are inputs

        AiryMajoraxis =         6377563.396            ' Airy Major Axis
        AiryMinoraxis =         6356256.910            ' Airy Minor Axis
        Airyesq =               0.0066705397616        '(AiryMajoraxis * AiryMajoraxis - AiryMinoraxis * AiryMinoraxis) / (AiryMajoraxis * AiryMajoraxis);
        WGS84Majoraxis = 6378137.000  ' WGS84 Major Axis
        WGS84Minoraxis = 6356752.3141 ' WGS84 Minor Axis
        WGS84esq = 0.0066943800355    ' (WGS84Majoraxis * WGS84Majoraxis - WGS84Minoraxis * WGS84Minoraxis) / (WGS84Majoraxis * WGS84Majoraxis);
' 7 parameter Helmert Transform coefficients OSGB - WGS84 values from from James Myatt paper
         tx = 446.448
         ty = -125.157
         tz = 542.060
         s = -20.4894e-6
         rx = 0.1502 / dr / 3600.0
         ry = 0.2470 / dr / 3600.0
         rz = 0.8421 / dr / 3600.0
         h = 0.0

        ' convert to radians
        lat1 = Lat1 / dr
        lon1 = Long1 / dr

        ' convert OSGB lat/lon to X,Y,Z
        v = AiryMajoraxis / SQR(1.0 - Airyesq * SIN(lat1) * SIN(lat1))     ' eqn 2.1
        x1 = (v + h) * COS(lat1) * COS(lon1)                                ' eqn 2.2
        y1 = (v + h) * COS(lat1) * SIN(lon1)                                ' eqn 2.3
        z1 = ((1.0 - Airyesq) * v + h) * SIN(lat1)                          ' eqn 2.4

        ' rotate and translate to new coordinate system
        ' with Helmert Transformation coefficients, eqn 3.1

        x2 = tx + (1.0 + s) * x1 - rz        * y1 + ry       * z1
        y2 = ty + rz        * x1 + (1.0 + s) * y1 - rx       * z1
        z2 = tz - ry        * x1 + rx        * y1 +(1.0 + s) * z1

        ' convert X,Y,Z to WGS84 lat/lon

        lon2 = ATAN2(x2, y2)

        p = SQR(x2 * x2 + y2 * y2)
        lat2 = ATAN2 (p * (1.0 - WGS84esq) , z2)

        DO
                lat = lat2
                v = WGS84Majoraxis / SQR(1.0 - WGS84esq * SIN(lat) * SIN(lat))
                lat2 = ATAN2(p, z2 + WGS84esq * v * SIN(lat))
        LOOP WHILE (ABS(lat - lat2) > 1.0e-8)
              Lat2 = lat2 * dr
              Long2 = lon2 * dr
END SUB
  '.................................................................................
SUB WGS84ToAiry(Lat1,Long1, Lat2, Long2)

' Converts WGS84 Lat/Long to Airy Geoid Lat/Long
' From the paper "The Geoid, James Myatt 7 July 2004"
' Lat and Long are inputs

        AiryMajoraxis =         6377563.396            ' Airy Major Axis
        AiryMinoraxis =         6356256.910            ' Airy Minor Axis
        Airyesq =               0.0066705397616        '(AiryMajoraxis * AiryMajoraxis - AiryMinoraxis * AiryMinoraxis) / (AiryMajoraxis * AiryMajoraxis);
        WGS84Majoraxis = 6378137.000  ' WGS84 Major Axis
        WGS84Minoraxis = 6356752.3141 ' WGS84 Minor Axis
        WGS84esq = 0.0066943800355    ' (WGS84Majoraxis * WGS84Majoraxis - WGS84Minoraxis * WGS84Minoraxis) / (WGS84Majoraxis * WGS84Majoraxis);

        ' 7 parameter Helmert Transform coefficients WGS84 - OSGB
         s = 20.4894e-6 ' scale factor
         tx = -446.448    ' x translation
         ty = 125.157   ' y translation
         tz = -542.060    ' z translation
         rx = -0.1502 / dr / 3600.0  ' x rotation
         ry = -0.2470 / dr / 3600.0  ' y rotation
         rz = -0.8421 / dr / 3600.0  ' z rotation
         h = 0.0 ' Ellipsoidal height (we will set this to zero)

        ' convert to radians
        lat1 = Lat1 / dr
        lon1 = Long1 / dr

        ' convert WGS84 lat/lon to X,Y,Z

        v = WGS84Majoraxis / SQR(1.0 - WGS84esq * SIN(lat1) * SIN(lat1))  ' eqn 2.1

        x1 = (v + h) * COS(lat1) * COS(lon1)                               ' eqn 2.2
        y1 = (v + h) * COS(lat1) * SIN(lon1)                               ' eqn 2.3
        z1 = ((1.0 - WGS84esq) * v + h) * SIN(lat1)                        ' eqn 2.4

        ' rotate and translate to new coordinate system
        ' with Helmert Transformation coefficients, eqn 3.1

        x2 = tx + (1.0 + s) * x1 - rz       * y1 + ry       * z1
        y2 = ty + rz       * x1 + (1.0 + s) * y1 - rx       * z1
        z2 = tz - ry       * x1 + rx        * y1 + (1.0 + s)* z1

        ' convert X,Y,Z back to lat/lon


        lon2 = ATAN2(x2, y2) ' eqn 2.5
        ' Latitude needs iteration

        p = SQR(x2 * x2 + y2 * y2)
        lat2 = ATAN2(p * (1.0 - WGS84esq), z2)


        DO
                lat = lat2
                v = AiryMajoraxis / SQR(1.0 - Airyesq * SIN(lat)* SIN(lat))
                lat2 = ATAN2(p,z2 + Airyesq * v * SIN(lat))

        LOOP WHILE (ABS(lat - lat2) > 1.0e-8)
        Lat2 = lat2 * dr
        Long2 = lon2 * dr
        Lat1 = lat1 * dr
        Long1 = lon1 * dr
 END SUB
  '.................................................................................

'.............................................................................................
SUB DecodeSite(lc$ , Lat, Lon, found%)       'Input is LOC, NGR or a name to search database for
    found% = 0
    c3$ = UCASE$(MID$(lc$, 3 , 1))
    c4$ = UCASE$(MID$(lc$, 4 , 1))

    IF c3$ > "9" OR c4$ > "9" THEN CALL FindSiteInDB(lc$ , Lat, Lon, Found%) : EXIT SUB

    c5$ = UCASE$(MID$(lc$, 5 , 1))
    c6$ = UCASE$(MID$(lc$, 6 , 1))

    IF c5$ >= "0" AND c5$ <= "9" AND c6$ >= "0" AND c6$ <= "9" THEN CALL DecodeNGR(lc$, Lat, Lon) : found% = -1
    IF c5$ >= "A" AND c5$ <= "X" AND c6$ >= "A" AND c6$ <= "X" THEN CALL LocToLL(lc$, Lat, Lon) : found% = -1
    IF found% = 0 THEN CALL FindSiteInDB(lc$ , Lat, Lon, Found%)
END SUB
'.............................................................................................
SUB FindSiteInDB(sn$ , Lat, Lon, Found%)   'Looks for sitename in database, extracts its location and generates its Lat/Long
    found% = 0
    fi$ = LocSites$ + "SITES.DAT"
    IF DIR$(fi$) = "" THEN PRINT fi$ ; " not found" : END
    OPEN fi$ FOR INPUT AS #1
    WHILE NOT EOF(1)
        LINE INPUT #1, s$
        p% = INSTR(s$ , "~")
        ss$ = LEFT$(s$ , p% - 1)
    LOOP UNTIL INSTR(UCASE$(ss$) , UCASE$(sn$)) OR EOF(1)
    IF EOF(1) THEN CLOSE 1 : EXIT SUB
    CLOSE 1
    COLOR 7
    Found% = -1
    p% = INSTR(s$ , "~")
    lc$ = UCASE$(MID$(s$ , p% + 1))

    p% = INSTR(lc$ , "~")
    IF p% THEN lc$ = LEFT$(lc$ , p% - 1)

    c5$ = UCASE$(MID$(lc$, 5 , 1))
    c6$ = UCASE$(MID$(lc$, 6 , 1))

    IF c5$ >= "0" AND c5$ <= "9" AND c6$ >= "0" AND c6$ <= "9" THEN ty% = 1
    IF c5$ >= "A" AND c5$ <= "X" AND c6$ >= "A" AND c6$ <= "X" THEN ty% = 2

    IF ty% = 0  THEN found% = 0 : EXIT SUB      'Invalid location is stored
    IF ty% = 1 THEN CALL DecodeNGR(lc$, Lat, Lon)
    IF ty% = 2 THEN CALL LocToLL(lc$, Lat, Lon)
    sn$ = ss$
END SUB
'.............................................................................................
SUB GenFile(Lat, Lon, Fi$)     'Generates .HGT file name from Lat/Long
    IF Lat < 0 THEN Fi$ = USING$("##",INT(ABS(Lat) + 1)) ELSE Fi$ = USING$("##",INT(ABS(Lat)))
    IF Lat < 0 THEN Fi$ = "S" + Fi$ ELSE Fi$ = "N" + Fi$
    IF Lon < 0 THEN Fi$ = Fi$ + "W" ELSE Fi$ = Fi$ + "E"
    IF Lon < 0 THEN Fi$ = Fi$ + USING$("###",INT(ABS(Lon) + 1)) & ".hgt" ELSE Fi$ = Fi$ + USING$("###",INT(ABS(Lon)), "000") & ".hgt"
    FOR x% = 1 TO LEN(fi$)
        IF MID$(fi$ , x% , 1) = " " THEN   MID$(fi$ , x% , 1) = "0"    'WHY can't USING$ give zero padding !!!!!!!!!!!!!
    NEXT x%
    Fi$ = HDBloc$ + Fi$
    IF DIR$(fi$) = "" THEN PRINT "No HDB for ";fi$ : fi$ = ""
END SUB
'.............................................................................................
SUB ReadFile(Fi$)      'Reads contents of 1 degree .HGT file into TileData(1200, 1200) array
    IF DIR$(fi$) = "" THEN PRINT "No Height file for this location" : EXIT SUB
    OPEN Fi$ FOR BINARY AS #1 BASE = 0
    fulldata$ = STRING$(2884802, 0)  ' = 1201 * 1201 * 2
    GET 1, 0, fulldata$         'Read entire contents into string
    CLOSE 1
    FOR y& = 0 TO 1200          'Then into X,Y array
        fp& = y& * 2402
        FOR x& = 0 TO 1201
            HiByte? = ASC(MID$(fulldata$, X& * 2 + 1 + fp&, 1))
            LoByte? = ASC(MID$(fulldata$, X& * 2 + 2 + fp&, 1))
            h& = LoByte? + 256 * HiByte?
            IF h& > 32768 THEN h& = h& - 65536      'Heights below zero.
            IF h& = 32768 THEN h& = 0       'Not sure what this is about
            Tiledata(x& , 1200 - y&) = h&      'File is stored downwards
  IF  Tiledata(x& , 1200 - y&)> 10000 OR Tiledata(x& , 1200 - y&) < -10000 THEN
      COLOR 13
      PRINT Tiledata(x& , 1200 - y&),fi$,HiByte?;LoByte?   , x&;y&
      COLOR 7
  END IF
        NEXT x&
    NEXT y&
END SUB
'.............................................................................................
SUB SpotHgtFile(Lat, Lon, h&)      'Identifes file and extracts spot height
    CALL GenFile(Lat, Lon, Fi$)
    IF DIR$(fi$) = "" THEN PRINT "No Height file for this location" : EXIT SUB
    OPEN Fi$ FOR BINARY AS #4 BASE = 0

    Y& = 1200 *(ABS(Lat) - INT(ABS(Lat)))
    IF Lat<0 THEN Y& = 1200 - Y&
    X& = 1200 * (ABS(Lon) - INT(ABS(Lon)))
    IF Lon < 0 THEN X& = 1200 - X&

    FilePntr& = 2 * X& + 2402 * (1201 -Y&)
    GET 4 , FilePntr&, HiByte?
    GET 4 ,, LoByte?

    h& = LoByte? + 256 * HiByte?
    IF h& > 32768 THEN h& = h& - 65536      'Heights below zero.
    IF h& = 32768 THEN h& = 0       'Not sure what this is about

'    COLOR 10 : PRINT fi$ ; X&;Y&;h&;"m    ";FilePntr& : COLOR 7
    CLOSE 4
END SUB
'....................................................................................................................
'.............................................................................................
SUB AlongBearing (BaseLat, BaseLon, Bearing, Distance, NewLat, NewLon)   'Gives Lat/Long from a specified point, dkm along a bearing
    GtArc = Distance / re
    lat1 = BaseLat / dr
    lon1 = BaseLon / dr
    theta = Bearing / dr

    Lat2 = ASIN(SIN(Lat1)*COS(GtArc) + COS(Lat1)*SIN(GtArc)*COS(theta))
    Lon2 = Lon1 + ATAN2( COS(GtArc)-SIN(Lat1)*SIN(Lat2),SIN(theta)*SIN(GtArc)*COS(Lat1))
    NewLat = Lat2 * dr
    NewLon = Lon2 * dr
END SUB
'.............................................................................................

SUB Cols(k&, co&)         ' Enter with K scaled 0 to 255, exit with waterfall RBG colour

    th1 = 256
    th2 = 511
    th3 = 767
    th4 = 1023
    th5 = 1279
    IF k& > 255 THEN k = 255
    IF k& < 0 THEN k = 0

    q = k& * 6
    s? = q MOD 256


       SELECT CASE q

        CASE IS <= th1       'black to blue
            r? = 0
            g? = 0
            b? = s?
        CASE IS <= th2       'blue to cyan
            r? = 0
            g? = s?
            b? = 255
        CASE IS <= th3       'cyan to green
            r? = 0
            g? = 255
            b? = 255 - s?
        CASE IS <= th4      'green to yellow
            r? = s?
            g? = 255
            b? = 0
        CASE IS <= th5      'yellow to red
            r? = 255
            g? = 255 - s?
            b? = 0
        CASE ELSE           'red to white
            r? = 255
            g? = s?
            b? = s?
        END SELECT

    co& = RGB(r?, g?, b?)

END SUB

SUB PlotTile          'Plots waterfall  of a single tile   (test prog only)
    GRAPHIC WINDOW NEW "Tile Height Plot"   , 800 , 60  , 300 * COS(51) , 300 TO HW&
    GRAPHIC SCALE (0,1201) - (1201 , 0)
    GRAPHIC ATTACH HW&, 0
    GRAPHIC WINDOW STABILIZE

       FOR y& = 1201 TO 0 STEP -1   'Plot downwards to make it look better
        FOR x& = 0 TO 1201
            c& = TileData(x& , y&)
            CALL cols(c& , col&)
            GRAPHIC SET PIXEL (x& , y&) , col&
        NEXT x&
    NEXT y&
END SUB
  '...........................................................
SUB NearestSite (BaseLat, BaseLon, sn$, MissDist)   'Searches database for site nearest to base, retunrs with name and distance from
 OPEN LocSites$ + "sites.dat" FOR INPUT AS #2
 MissDist = 9999999
 WHILE NOT EOF(2)
    LINE INPUT #2, s$
    p% = INSTR(s$ , "~")
    ss$ = LEFT$(s$ , p% - 1)
    lc$ = UCASE$(MID$(s$ , p% + 1))
    p% = INSTR(lc$ , "~")
    IF p% THEN lc$ = LEFT$(lc$ , p% - 1)

    c5$ = UCASE$(MID$(lc$, 5 , 1))
    c6$ = UCASE$(MID$(lc$, 6 , 1))

    IF c5$ >= "0" AND c5$ <= "9" AND c6$ >= "0" AND c6$ <= "9" THEN ty% = 1
    IF c5$ >= "A" AND c5$ <= "X" AND c6$ >= "A" AND c6$ <= "X" THEN ty% = 2

    IF ty% = 0  THEN ITERATE LOOP      'Invalid location is stored
    IF ty% = 1 THEN CALL DecodeNGR(lc$, Lat, Lon)
    IF ty% = 2 THEN CALL LocToLL(lc$, Lat, Lon)

    CALL DistBear(BaseLat, BaseLon, Lat, Lon, Dist, Bearing, BackBearing)
    IF Dist < MissDist THEN sn$ = ss$ : MissDist = Dist
 LOOP UNTIL EOF(2)
 CLOSE 2
END SUB
'...............................................
